Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Construct.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Construct.java	(revision 3946)
@@ -234,5 +234,4 @@
 	    get_status_only = true;
 	}
-	System.out.println("get status only = "+get_status_only);
 	if (get_status_only) {
 	    // at the moment, delete is synchronous. but it may take ages so should do the command in another thread maybe? in which case we will want to ask for status
@@ -480,9 +479,7 @@
 	    get_status_only = true;
 	}
-	System.out.println("get status only = "+get_status_only);
 	
 	// just check for status messages if that's all that's required
 	if (get_status_only) {
-	    System.out.println("in get status only bit");
 	    String id = (String)params.get(HANDLE_PARAM);
 	    GS2PerlListener listener = (GS2PerlListener)listeners_.get(id);
@@ -503,5 +500,4 @@
 
 	}
-	System.out.println("not in get status only bit");
 
 	// do teh actual command
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGPPSearch.java	(revision 3946)
@@ -435,5 +435,5 @@
 	default:
 	    // should never get here
-	    System.out.println("wrong query type!!");
+	    System.err.println("GS2MGPPSearch: wrong query type!!");
 	    return null;
 	}
@@ -471,6 +471,4 @@
 	String basedir = GSFile.collectionBaseDir(site_home_, cluster_name_);
 	String indexdir = GSFile.collectionIndexPath(cluster_name_, index);
-	System.out.println("Base directory: " + basedir);
-	System.out.println("Index directory: " + indexdir);
 
 	mgpp_src_.loadIndexData(basedir, indexdir);
@@ -615,5 +613,4 @@
 	}
 
-	System.out.println("final query = "+final_query.toString());
 	return final_query.toString();
     }
@@ -657,5 +654,4 @@
 	}
 
-	System.out.println("final query = "+final_query.toString());
 	return final_query.toString();
     }
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGSearch.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGSearch.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2MGSearch.java	(revision 3946)
@@ -136,5 +136,5 @@
 	Vector docs = mqr.getDocs();
 	if (docs.size() == 0) {
-	    System.out.println("Warning: No results found...\n");
+	    System.err.println("GS2MGSearch: Warning: No results found...\n");
 	}
 
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Retrieve.java	(revision 3946)
@@ -198,5 +198,5 @@
 						       name);
 	    if (node_extra == null) {
-		System.out.println("haven't found extra info for classifier named "+name);
+		System.err.println("GS2REtrieve: haven't found extra info for classifier named "+name);
 		continue;
 	    }
@@ -433,5 +433,4 @@
 		if (param.getAttribute(GSXML.NAME_ATT) == "structure") {
 		    String structure = GSXML.getValue(param);
-		    // System.out.println("Structure desired: " + structure);
 
 		    // This is NOT locale sensitive
@@ -535,6 +534,4 @@
 		addDescendants(current, doc_id, true);
 	}
-	//System.out.println("the result of structure retrieve is");
-	//System.out.println(converter_.getString(result));
 	return result;
     }
@@ -585,5 +582,4 @@
 	    if (param.getAttribute(GSXML.NAME_ATT) == "metadata") {
 		String metadata = GSXML.getValue(param);
-		System.out.println("Metadata desired: " + metadata);
 		metadata_list.add(metadata);
 	    }
@@ -605,6 +601,4 @@
 	    Element request_node = (Element) request_nodes.item(i);
 	    String node_id = request_node.getAttribute(GSXML.NODE_ID_ATT);
-	    System.out.println("Retrieving metadata for " + node_id + "...");
-
 
 	    if (OID.needsTranslating(node_id)) {
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Search.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Search.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/GS2Search.java	(revision 3946)
@@ -150,5 +150,5 @@
 						       name);
 	    if (node_extra == null) {
-		System.out.println("haven't found extra info for index named "+name);
+		System.err.println("GS2Search: haven't found extra info for index named "+name);
 		continue;
 	    }
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/PhindPhraseBrowse.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/PhindPhraseBrowse.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/PhindPhraseBrowse.java	(revision 3946)
@@ -150,5 +150,4 @@
 	    }
 	    phrase = findPhraseNumberFromWord( word);
-	    System.out.println("phind, term number for "+word+" is "+phrase);
 	}
 	if (phrase==0) {
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/ServiceRack.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/ServiceRack.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/ServiceRack.java	(revision 3946)
@@ -198,8 +198,7 @@
 			    break;
 			} catch (NoSuchMethodException e) {
-			    System.out.println("method not found for this class, trying super class");
 			    c = c.getSuperclass();
 			} catch (SecurityException e) {
-			    System.out.println("security exception for finding a method, returning null");
+			    System.err.println("ServiceRack.process: security exception for finding method "+method_name+", returning null");
 			    return null;
 			}
@@ -211,9 +210,9 @@
 			    
 			} catch (Exception e) {
-			    System.out.println("ServiceRack: Trying to call a processService type method (process"+to+") on a subclass("+this.getClass().getName()+"), but an exception happened:"+e.toString());
+			    System.err.println("ServiceRack.process: Trying to call a processService type method (process"+to+") on a subclass("+this.getClass().getName()+"), but an exception happened:"+e.toString());
 			    return null;
 			}
 		    } else {
-			System.out.println("no method found");
+			System.err.println("ServiceRack.process: method "+method_name+" not found for class "+this.getClass().getName());
 		    }
 		    if (response !=null) {
@@ -222,5 +221,5 @@
 		    		   
 		    } catch (ClassNotFoundException e) {
-			System.out.println("ServiceRack error:element class not found");
+			System.err.println("ServiceRack error: Element class not found");
 			return null;
 		    }
Index: trunk/gsdl3/src/java/org/greenstone/gsdl3/service/XSLTServices.java
===================================================================
--- trunk/gsdl3/src/java/org/greenstone/gsdl3/service/XSLTServices.java	(revision 3945)
+++ trunk/gsdl3/src/java/org/greenstone/gsdl3/service/XSLTServices.java	(revision 3946)
@@ -114,5 +114,5 @@
       transformer.transform(source,result);
     } catch (Throwable t) {
-      System.out.println("Error printing XML in XSLTService::configure()");
+      System.err.println("Error printing XML in XSLTService::configure()");
     }
     return true;    