Index: trunk/gsdl3/web/interfaces/default/transform/about.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4146)
@@ -56,5 +56,5 @@
 <xsl:template match="serviceList">
 <xsl:param name="collName">coll-name</xsl:param>
-<xsl:variable name="library" select="ancestor::page/config/library_name"/>
+<xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
 <h2><xsl:call-template name="text"><xsl:with-param name="key">about.services</xsl:with-param></xsl:call-template></h2>
 <xsl:if test="count(service) > 0">
Index: trunk/gsdl3/web/interfaces/default/transform/basicquery.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/basicquery.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/basicquery.xsl	(revision 4146)
@@ -79,5 +79,5 @@
 <xsl:param name="collName">coll-name</xsl:param>
 <xsl:variable name="subaction"><xsl:value-of select="../request/@subaction"/></xsl:variable>
-<xsl:variable name='library' select='ancestor::page/config/library_name'/>
+<xsl:variable name='library' select='ancestor::page/pageExtra/config/library_name'/>
 <h3><xsl:value-of select="display/name"/></h3><p/>
 <form name="QueryForm" method="get" action="/gsdl3/{$library}">
@@ -136,5 +136,5 @@
 <xsl:template match="documentNode">
   <xsl:param name="collName"/>
-  <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+  <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
 
   <td>
Index: trunk/gsdl3/web/interfaces/default/transform/classifier.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4146)
@@ -37,5 +37,5 @@
     <xsl:param name="collName"/>
     <xsl:param name="serviceName"/>
-    <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+    <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
     <xsl:variable name="selected" select="ancestor::page/pageResponse/classifier/@name"/>
     <table width='537'><tr>
@@ -163,5 +163,5 @@
 <xsl:template match="documentNode">
 <xsl:param name="collName">coll-name</xsl:param>
-<xsl:variable name='library' select='ancestor::page/config/library_name'/>
+<xsl:variable name='library' select='ancestor::page/pageExtra/config/library_name'/>
 <td><a href="{$library}?a=d&amp;c={$collName}&amp;d={@nodeID}"><img src='interfaces/default/images/book.gif' width='18' height='11' border='0'/></a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
 </xsl:template>
@@ -170,5 +170,5 @@
     <xslt:param name="collName">coll-name</xslt:param>
  
-    <xslt:variable name="library" select="ancestor::page/config/library_name" />    <td>
+    <xslt:variable name="library" select="ancestor::page/pageExtra/config/library_name" />    <td>
       <a href="{$library}?a=d&amp;c={$collName}&amp;d={@nodeID}">
         <img border="0" height="11" src="interfaces/default/images/book.gif" width="18" /></a>
@@ -183,5 +183,5 @@
     <xsl:param name="collName">coll-name</xsl:param>
     <xsl:param name="serviceName">service-name</xsl:param>
-    <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+    <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
     <td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;s=<xsl:value-of select='$serviceName'/>&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@nodeID'/><xsl:if test="classifierNode|documentNode">.pr</xsl:if></xsl:attribute><img src='interfaces/default/images/bshelf.gif' border='0' width='20' height='16' /></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
   </xsl:template>
@@ -192,5 +192,5 @@
     <xsl:param name="collName">coll-name</xsl:param>
     <xsl:param name="serviceName">service-name</xsl:param>
-    <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+    <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
     <td><a><xsl:attribute name='href'><xsl:value-of select='$library'/>?a=b&amp;s=<xsl:value-of select='$serviceName'/>&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@nodeID'/><xsl:if test="classifierNode|documentNode">.pr</xsl:if></xsl:attribute><xsl:value-of select="metadataList/metadata[@name='Title']"/></a></td>
   </xsl:template>
Index: trunk/gsdl3/web/interfaces/default/transform/document.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/document.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/document.xsl	(revision 4146)
@@ -103,5 +103,5 @@
   <xsl:param name="collName"/>
   <xsl:param name="depth"/>
-  <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+  <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
   <xsl:variable name="space" select="$depth * 25"/>
 
@@ -145,5 +145,5 @@
     <xsl:param name="collName"/>
     <xsl:variable name="docID" select="ancestor::page/pageRequest/paramList/param[@name='d']/@value"/>
-    <xsl:variable name='library' select='ancestor::page/config/library_name'/>
+    <xsl:variable name='library' select='ancestor::page/pageExtra/config/library_name'/>
     <xsl:for-each select="service">
       <table border='1' cellspacing='0'><tr><td>
Index: trunk/gsdl3/web/interfaces/default/transform/home.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/home.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/home.xsl	(revision 4146)
@@ -29,5 +29,5 @@
 	<a>
 	  <xsl:attribute name='href'>
-	    <xsl:value-of select="ancestor::page/config/library_name"/>?a=p&amp;sa=about&amp;c=<xsl:value-of select='@name'/>
+	    <xsl:value-of select="ancestor::page/pageExtra/config/library_name"/>?a=p&amp;sa=about&amp;c=<xsl:value-of select='@name'/>
 	  </xsl:attribute>
 	  <img width="150" border="1">
@@ -53,5 +53,5 @@
 <xsl:template match="serviceClusterList">
 <xsl:for-each select="serviceCluster"> 
-<p/><a><xsl:attribute name='href'><xsl:value-of select="ancestor::page/config/library_name"/>?a=p&amp;sa=about&amp;c=<xsl:value-of select='@name'/></xsl:attribute><xsl:value-of select='@name'/></a>
+<p/><a><xsl:attribute name='href'><xsl:value-of select="ancestor::page/pageExtra/config/library_name"/>?a=p&amp;sa=about&amp;c=<xsl:value-of select='@name'/></xsl:attribute><xsl:value-of select='@name'/></a>
 </xsl:for-each>
 <xsl:call-template name="greenBar"/>
Index: trunk/gsdl3/web/interfaces/default/transform/process.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/process.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/process.xsl	(revision 4146)
@@ -31,5 +31,5 @@
   <xsl:template match="service">
     <xsl:param name="clusterName">cluster-name</xsl:param>
-    <xsl:variable name='library' select='ancestor::page/config/library_name'/>
+    <xsl:variable name='library' select='ancestor::page/pageExtra/config/library_name'/>
     <xsl:variable name='subaction' select="ancestor::page/pageRequest/@subaction"/>
     <xsl:variable name='action' select="ancestor::page/pageRequest/@action"/>
@@ -70,5 +70,5 @@
 <xsl:param name="clusterName">cluster-name</xsl:param>
 <center/>
-<applet code="org.greenstone.gsdl3.build.StatusDisplay.class" codebase='lib/java' archive='gsdl3.jar, xercesImpl.jar, jaxp.jar, xml-apis.jar' width='537' height='100'>The status display applet.<param name='library'><xsl:attribute name="value"><xsl:value-of select='ancestor::page/config/library_name'/>?a=pr&amp;rt=s&amp;c=<xsl:value-of select='$clusterName'/>&amp;s=<xsl:value-of select='ancestor::page/pageResponse/service/@name'/>&amp;o=xml&amp;ro=1&amp;l=<xsl:value-of select='ancestor::page/pageRequest/@lang'/>&amp;pid=<xsl:value-of select="@pid"/><xsl:apply-templates select="ancestor::page/pageResponse/service/paramList" mode="cgi"/></xsl:attribute></param><param name='initial_text'><xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute></param><param name='initial_code'><xsl:attribute name="value"><xsl:value-of  select="@code"/></xsl:attribute></param></applet>
+<applet code="org.greenstone.gsdl3.build.StatusDisplay.class" codebase='lib/java' archive='gsdl3.jar, xercesImpl.jar, jaxp.jar, xml-apis.jar' width='537' height='100'>The status display applet.<param name='library'><xsl:attribute name="value"><xsl:value-of select='ancestor::page/pageExtra/config/library_name'/>?a=pr&amp;rt=s&amp;c=<xsl:value-of select='$clusterName'/>&amp;s=<xsl:value-of select='ancestor::page/pageResponse/service/@name'/>&amp;o=xml&amp;ro=1&amp;l=<xsl:value-of select='ancestor::page/pageRequest/@lang'/>&amp;pid=<xsl:value-of select="@pid"/><xsl:apply-templates select="ancestor::page/pageResponse/service/paramList" mode="cgi"/></xsl:attribute></param><param name='initial_text'><xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute></param><param name='initial_code'><xsl:attribute name="value"><xsl:value-of  select="@code"/></xsl:attribute></param></applet>
 <xsl:call-template name="greenBar"/>
 </xsl:template>
Index: trunk/gsdl3/web/interfaces/default/transform/style.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/style.xsl	(revision 4145)
+++ trunk/gsdl3/web/interfaces/default/transform/style.xsl	(revision 4146)
@@ -79,5 +79,5 @@
     <xsl:variable name="httpPath" select="ancestor::page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
     <xsl:variable name="colIcon" select="ancestor::page/pageResponse/collection/metadataList/metadata[@name='colIcon']"/>
-    <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+    <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
     <table width="537">
       <tr>
@@ -113,5 +113,5 @@
   <xsl:template name="clusterPageBanner">
     <xsl:param name="clusterName"/>
-    <xsl:variable name="library" select="ancestor::page/config/library_name"/>
+    <xsl:variable name="library" select="ancestor::page/pageExtra/config/library_name"/>
     <table width="537">
       <tr><td align="left"><a href="{$library}?a=p&amp;sa=about&amp;c={$clusterName}"><xsl:value-of select="$clusterName"/></a></td><td align="right"><a href="{$library}?a=p&amp;sa=home"><xsl:call-template name="text"><xsl:with-param name="key">home</xsl:with-param></xsl:call-template></a></td></tr></table>
@@ -187,5 +187,5 @@
 <xsl:template name="text" match="text">
 <xsl:param name="key"><xsl:value-of select="@name"/></xsl:param>
-<xsl:variable name="path">ancestor::page/display/<xsl:value-of select='$key'/></xsl:variable>
+<xsl:variable name="path">ancestor::page/pageExtra/display/<xsl:value-of select='$key'/></xsl:variable>
 <xsl:variable name="string1"><xsl:value-of select="java:org.apache.xalan.lib.Extensions.evaluate($path)"/></xsl:variable>
 <xsl:choose><xsl:when test="boolean(string($string1))"><xsl:value-of select="$string1"/></xsl:when>