Index: trunk/gsdl/bin/script/gimp/flash_button-1.2.pl
===================================================================
--- trunk/gsdl/bin/script/gimp/flash_button-1.2.pl	(revision 4211)
+++ trunk/gsdl/bin/script/gimp/flash_button-1.2.pl	(revision 4228)
@@ -222,10 +222,21 @@
 	my $y_offset = ($height-$textheight)-int($fontsize/5);
 
-
-	# my $halfdescenders = "";
-	# russian half descenders (KOI8-R)
+	my $halfdescenders = "";
+
+	# Russian half descenders (KOI8-R)
+	# -- Uncomment if generating Russian images using KOI8-R encoded text --
 	# $halfdescenders .= chr(195) . chr(253);  # Checked
-	# $halfdescenders .= chr(196) . chr(198) . chr(221) . chr(227) . chr(228);  # Unchecked
-
+	# $halfdescenders .= chr(196) . chr(198) . chr(221) . chr(227) . chr(228); # Unchecked
+
+	# Kazakh (and Russian) half descenders (Helvetica Kazakh font)
+	# -- Uncomment if generating Kazakh or Russian images using text encoded to match
+	#      a Kazakh Helvetica font:
+        #        http://www.unesco.kz/ci/projects/greenstone/kazakh_fonts/helv_k.ttf
+	#    Mapping for this encoding is: mapping/from_uc/kazakh.ump --
+	# $halfdescenders .= chr(178) . chr(179) . chr(187);             # Kazakh specific
+	# $halfdescenders .= chr(196) . chr(214) . chr(217) . chr(228);  # Generic Russian
+	# $halfdescenders .= chr(244) . chr(246) . chr(249);
+
+	# -- Uncomment if generating images using a font with half descenders --
 	# if ($text =~ /[$halfdescenders]/) {
 	    # half descenders - put text at fontsize/10 pixels above bottom
@@ -234,6 +245,16 @@
 
 	my $descenders = "";
-	# russian descenders (KOI8-R)
+
+	# Russian descenders (KOI8-R)
+	# -- Uncomment if generating Russian images using KOI8-R encoded text --
 	# $descenders .= chr(210) . chr(213);
+
+	# Kazakh (and Russian) descenders (Helvetica Kazakh font)
+	# -- Uncomment if generating Kazakh or Russian images using text encoded to match
+	#      a Kazakh Helvetica font:
+        #        http://www.unesco.kz/ci/projects/greenstone/kazakh_fonts/helv_k.ttf
+	#    Mapping for this encoding is: mapping/from_uc/kazakh.ump --
+	# $descenders .= chr(189) . chr(190);  # Kazakh specific
+	# $descenders .= chr(240) . chr(243);  # Generic Russian
 
 	if ($text =~ /[gjpqyJ$descenders]/) { ## capital J is a descender in lucida font
Index: trunk/gsdl/bin/script/gimp/green_bar-1.2.pl
===================================================================
--- trunk/gsdl/bin/script/gimp/green_bar-1.2.pl	(revision 4211)
+++ trunk/gsdl/bin/script/gimp/green_bar-1.2.pl	(revision 4228)
@@ -204,9 +204,21 @@
 	my $y_offset = ($height-$textheight)-int($fontsize/5);
 
-	# my $halfdescenders = "";
-	# russian half descenders (KOI8-R)
+	my $halfdescenders = "";
+
+	# Russian half descenders (KOI8-R)
+	# -- Uncomment if generating Russian images using KOI8-R encoded text --
 	# $halfdescenders .= chr(195) . chr(253);  # Checked
-	# $halfdescenders .= chr(196) . chr(198) . chr(221) . chr(227) . chr(228);  # Unchecked
-
+	# $halfdescenders .= chr(196) . chr(198) . chr(221) . chr(227) . chr(228); # Unchecked
+
+	# Kazakh (and Russian) half descenders (Helvetica Kazakh font)
+	# -- Uncomment if generating Kazakh or Russian images using text encoded to match
+	#      a Kazakh Helvetica font:
+        #        http://www.unesco.kz/ci/projects/greenstone/kazakh_fonts/helv_k.ttf
+	#    Mapping for this encoding is: mapping/from_uc/kazakh.ump --
+	# $halfdescenders .= chr(178) . chr(179) . chr(187);             # Kazakh specific
+	# $halfdescenders .= chr(196) . chr(214) . chr(217) . chr(228);  # Generic Russian
+	# $halfdescenders .= chr(244) . chr(246) . chr(249);
+
+	# -- Uncomment if generating images using a font with half descenders --
 	# if ($text =~ /[$halfdescenders]/) {
 	    # half descenders - put text at fontsize/10 pixels above bottom
@@ -215,6 +227,16 @@
 
 	my $descenders = "";
-	# russian descenders (KOI8-R)
+
+	# Russian descenders (KOI8-R)
+	# -- Uncomment if generating Russian images using KOI8-R encoded text --
 	# $descenders .= chr(210) . chr(213);
+
+	# Kazakh (and Russian) descenders (Helvetica Kazakh font)
+	# -- Uncomment if generating Kazakh or Russian images using text encoded to match
+	#      a Kazakh Helvetica font:
+        #        http://www.unesco.kz/ci/projects/greenstone/kazakh_fonts/helv_k.ttf
+	#    Mapping for this encoding is: mapping/from_uc/kazakh.ump --
+	# $descenders .= chr(189) . chr(190);  # Kazakh specific
+	# $descenders .= chr(240) . chr(243);  # Generic Russian
 
 	if ($text =~ /[gjpqyJ$descenders]/) { ## capital J is a descender in lucida font